image: node:10

stages:
  - build
  - test
  - deploy staging
  - deploy production
  - production tests
  - cache

variables:
  STAGING_DOMAIN: siemama-staging.surge.sh
  PRODUCTION_DOMAIN: siemama.surge.sh

cache:
  key: ${CI_COMMIT_REF_SLUG}
  paths:
    - node_modules/
  policy: pull
  
update cache:
  stage: cache
  script:
    - npm install
  cache:
      key: ${CI_COMMIT_REF_SLUG}
      paths:
        - node_modules/
      policy: push
  only:
    - schedules

build website:
  stage: build
  script:
    - echo $CI_COMMIT_SHORT_SHA
    - npm install
    - npm install -g gatsby-cli
    - gatsby build
    - sed -i "s/%%VERSION%%/$CI_COMMIT_SHORT_SHA/" ./public/index.html
  artifacts:
    paths:
      - ./public
  except:
   - schedules

test artifact:
  image: alpine
  stage: test
  cache: {}
  script:
    - grep -q "Gatsby" ./public/index.html
  except:
   - schedules    

test website:
  stage: test
  script:
    - npm install
    - npm install -g gatsby-cli
    - gatsby serve &
    - sleep 3
    - curl "http://localhost:9000" | tac | tac | grep -q "Gatsby"
  except:
   - schedules    

deploy staging to surge: 
  stage: deploy staging
  environment:
    name: staging
    url: https://$STAGING_DOMAIN
  cache: {}
  script:
    - npm install --global surge
    - surge --project ./public --domain $STAGING_DOMAIN
  except:
    - schedules   
  only: 
    - master

deploy production to surge: 
  stage: deploy production
  environment:
    name: production
    url: http://$PRODUCTION_DOMAIN
  cache: {}
  when: manual
  allow_failure: false
  script:
    - npm install --global surge
    - surge --project ./public --domain $PRODUCTION_DOMAIN
  except:
   - schedules    
  only: 
    - master

test production:
  image: alpine
  cache: {}
  stage: production tests
  script:
    - apk add --no-cache curl
    - curl -s "https://$PRODUCTION_DOMAIN" | grep -q "Hi people"
    - curl -s "https://$PRODUCTION_DOMAIN" | grep -q "$CI_COMMIT_SHORT_SHA"
  except:
   - schedules    
  only: 
    - master